<template>
  <q-card
    :square="!isDesktopPlatform"
    :class="{ 'organic-manure-application-edit-form-desktop': isDesktopPlatform, 'organic-manure-application-edit-form-mobile': !isDesktopPlatform }"
  >
    <q-form @submit="onSubmit">
      <q-card-section>
        <q-select
          v-model="animalCategory"
          :options="organicManureAnimalCategoryOptions"
          option-value="id"
          :option-label="getRequafertiI18NFieldName('libelle')"
          filled
          :label="$gettext('Animal category')"
          :rules="[
            val => Boolean(val) || $gettext('Select an animal category'),
          ]"
          @update:model-value="onAnimalCategoryChange"
          hide-bottom-space
        />

        <q-select
          v-model="organicMatterType"
          :options="organicMatterTypeOptions"
          option-value="type_eff_xid"
          :option-label="getRequafertiI18NFieldName('type_eff_libelle')"
          filled
          :label="$gettext('Organic matter type')"
          :rules="[
            val => !hasOrganicMatterTypeOptions || Boolean(val) || $gettext('Select a type'),
          ]"
          :disable="!hasOrganicMatterTypeOptions"
          @update:model-value="onOrganicMatterTypeChange"
          hide-bottom-space
          class="q-mt-md"
        />

        <q-input
          v-model.number="effluentQuantity"
          step="any"
          filled
          type="number"
          :label="$gettext('Effluent quantity')"
          :suffix="$gettext('t/ha')"
          :min="0"
          :rules="[ val => val && val > 0 || $gettext('Enter a positive quantity')]"
          hide-bottom-space
          class="q-mt-md"
        />

        <q-input
          v-model.number="nitrogenContent"
          step="any"
          filled
          type="number"
          :label="$gettext('Fresh matter nitrogen content')"
          :suffix="$gettext('kg N/t')"
          :min="0"
          :rules="[ val => val && val > 0 || $gettext('Enter a positive content')]"
          hide-bottom-space
          class="q-mt-md"
        />

        <DateSelectorInput
          v-model="applicationDate"
          :date-options="applicationDateOptions"
          :readonly="false"
          :rules="[ val => val !== null && val !== undefined || $gettext('Select a date') ]"
          :label="$gettext('Application date')"
          class="q-mt-md"
        />
      </q-card-section>

      <q-card-section class="q-py-lg">
        <div class="row justify-end items-center">
          <q-btn
            :label="$gettext('Cancel')"
            flat
            @click="onCancel"
          />
          <q-btn
            :label="$gettext('Remove')"
            flat
            color="red"
            @click="onDelete"
            v-if="!isNew"
          />
          <q-btn
            :label="saveButtonLabel"
            flat
            color="primary"
            type="submit"
          />
        </div>
      </q-card-section>
    </q-form>
  </q-card>
</template>

<script>
import { date } from 'quasar'

import { PlatformMixin } from 'src/mixins/PlatformMixin'
import RequafertiI18nMixin from 'src/pages/fieldbook/fertilization/algorithms/requaferti/mixins/RequafertiI18nMixin'
import DateSelectorInput from 'src/components/form/DateSelectorInput'

export default {
  name: 'RequafertiOrganicManureApplicationEditForm',
  mixins: [
    PlatformMixin,
    RequafertiI18nMixin
  ],
  components: {
    DateSelectorInput
  },
  props: {
    organicManureAnimalCategoryOptions: {
      type: Array,
      required: true
    },
    organicManureApplicationCombinations: {
      type: Array,
      required: true
    },
    id: {
      type: Number,
      default: null
    },
    initialAnimalCategory: {
      type: Object,
      default: null
    },
    initialOrganicMatterType: {
      type: Object,
      default: null
    },
    initialEffluentQuantity: {
      type: Number,
      default: null
    },
    initialNitrogenContent: {
      type: Number,
      default: null
    },
    initialApplicationDate: {
      type: [String, Date],
      default: null
    }
  },
  emits: ['on-save', 'on-cancel', 'on-delete'],
  data () {
    return {
      animalCategory: this.initialAnimalCategory,
      organicMatterType: this.initialOrganicMatterType,
      effluentQuantity: this.initialEffluentQuantity,
      nitrogenContent: this.initialNitrogenContent,
      applicationDate: this.initialApplicationDate
    }
  },
  computed: {
    isNew () {
      return !this.id
    },
    saveButtonLabel () {
      return this.isNew ? this.$gettext('Add') : this.$gettext('Update')
    },
    organicMatterTypeOptions () {
      if (!this.animalCategory) {
        return []
      } else {
        return this.organicManureApplicationCombinations.filter(combination => combination.grp_ani_xid === this.animalCategory.id)
      }
    },
    hasOrganicMatterTypeOptions () {
      return this.organicMatterTypeOptions?.length > 0
    },
    applicationDateOptions () {
      const now = date.formatDate(new Date(), 'YYYY/MM/DD')
      return date => date <= now
    }
  },
  methods: {
    onSubmit () {
      if (this.animalCategory && this.effluentQuantity) {
        this.$emit('on-save', {
          id: this.id,
          animalCategory: this.animalCategory,
          organicMatterType: this.organicMatterType,
          effluentQuantity: this.effluentQuantity,
          nitrogenContent: this.nitrogenContent,
          applicationDate: this.applicationDate
        })
      }
    },
    onCancel () {
      this.$emit('on-cancel')
    },
    onDelete () {
      this.$emit('on-delete', this.id)
    },
    onAnimalCategoryChange () {
      this.organicMatterType = null
      this.nitrogenContent = null
    },
    onOrganicMatterTypeChange () {
      const organicMatter = this.organicManureApplicationCombinations.find(combination => combination.type_eff_xid === this.organicMatterType?.type_eff_xid)
      if (organicMatter) {
        this.nitrogenContent = Number(organicMatter.azote_total)
      } else {
        this.nitrogenContent = null
      }
    }
  }
}
</script>

<style scoped>
.organic-manure-application-edit-form-desktop {
  min-width: 500px;
}
.organic-manure-application-edit-form-mobile {
  width: 100%;
}
</style>
